<?php

include_once "lib-servipag/flowlib.php";
include_once "lib-servipag/flowlib.whmcs.php";

function flowservipag_config() {
	$platform_options = implode(',', flowservipag_get_platform_options());
	$payment_type_options = implode(',', flowservipag_get_payment_type_options()); 
	$skip_type_options = implode(',', flowservipag_get_skip_type_options()); 
	$configarray = array(
	"FriendlyName" => array("Type" => "System", "Value"=>"Flow Servipag"),
	"platform_id" => array("FriendlyName" => "Plataforma de Flow", "Type" => "dropdown", "Options" => $platform_options), 
	"receiver_id" => array("FriendlyName" => "ID Comercio Flow", "Type" => "text", "Size" => "25"), 
	"skip_type_id" => array("FriendlyName" => "Modo de acceso a Servipag", "Type" => "dropdown", "Options" => $skip_type_options), 
	"secret" => array("FriendlyName" => "Llave privada Flow", "Type" => "textarea", "Rows" => 5, "Cols" => "120"),
    );
	return $configarray;
}

function flowservipag_link($params) {

	// translate string to codes.  WHMCS => whCSM
	$platform_id = array_search($params['platform_id'], flowservipag_get_platform_options());
	$skip_type_id = array_search($params['skip_type_id'], flowservipag_get_skip_type_options());
	
	$platform_url = $platform_id != 0?flowservipag_get_endpoint():flowservipag_get_endpoint_test();
	
	$pay_now_text = $params['langpaynow'];
	$payer_email = $params['clientdetails']['email'];
	
	$privkey = $params['secret'];
	$flow_comercio = $params['receiver_id'];
	$orden_compra = $params['invoiceid'];
	$monto = intval($params['amount']);
	$medioPago = 2;
	$concepto = $params['description'].' '.$payer_email;
	$id_producto = $payer_email;
	$flow_url_exito = $params['systemurl'].'/viewinvoice.php?id='.$params['invoiceid'].'&paymentsuccess=true';
	$flow_url_fracaso = $params['systemurl'].'/viewinvoice.php?id='.$params['invoiceid'].'&paymentsuccess=false';
	$flow_url_confirmacion = $params['systemurl'].'/modules/gateways/callback/flowservipag.php';
	
	$tipo_integracion = $skip_type_id == 0?"d":"f";
	$email = $payer_email;
	
	$data_request = flowservipag_pack($privkey, $flow_comercio, $orden_compra, $monto, $medioPago, $concepto, $id_producto, 
			$flow_url_exito, $flow_url_fracaso, $flow_url_confirmacion,
			$tipo_integracion, $email);
	
	$code = '<form action="'.$platform_url.'" method="post">'.
		'<input type="hidden" name="parameters" value="'.$data_request.'">'.
		'<input type="submit" value="'.$pay_now_text.'" class="btn btn-primary" /></form>';
	
	return $code;
}


?>
